function calculate(x) {
  return x;
}

calculate.description = "这是一个十分耗费性能的计算函数！";
console.log("calculate.description：", calculate.description);

function cachingDecorator(fn) {
  // 我们用 map 结构来保存数据
  const cache = new Map();

  // 返回一个函数
  return function (x) {
    // 从缓存中读取
    if (cache.has(x)) {
      // 为了大家能方便的看到效果增加一条输出语句
      console.log(`从缓存中读取：${cache.get(x)}`);
      return cache.get(x);
    }
    // 执行
    // const result = fn.call(this, x);
    const result = fn(x);

    // 为了大家能方便的看到效果增加一条输出语句
    console.log(`新值：${result}`);

    // 把新的值存入缓存
    cache.set(x, result);

    return result;
  };
}

const excute = cachingDecorator(calculate);
console.log("excute.description：", excute.description); // undefined
